"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var React = require("react"), box = require("@kodiak-ui/primitives/box"), useMeasure = require("@kodiak-ui/hooks/use-measure");

function _extends() {
  return (_extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _objectWithoutProperties(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function Progress(_ref) {
  var value = _ref.value, _ref$min = _ref.min, min = void 0 === _ref$min ? 0 : _ref$min, _ref$max = _ref.max, max = void 0 === _ref$max ? 100 : _ref$max, _ref$color = _ref.color, color = void 0 === _ref$color ? "primary" : _ref$color, _ref$containerVariant = _ref.containerVariant, containerVariant = void 0 === _ref$containerVariant ? "container" : _ref$containerVariant, _ref$barVariant = _ref.barVariant, barVariant = void 0 === _ref$barVariant ? "bar" : _ref$barVariant, children = _ref.children, progressSx = _ref.progressSx, props = _objectWithoutProperties(_ref, [ "value", "min", "max", "color", "containerVariant", "barVariant", "children", "progressSx" ]), progressWidth = 100 * (value - min) / (max - min);
  return React.createElement(box.Box, _extends({
    __base: {
      bg: "muted",
      borderRadius: "default",
      height: "12px"
    },
    variant: containerVariant,
    variantKey: "progresses"
  }, props), React.createElement(box.Box, {
    __base: {
      bg: color,
      height: "100%",
      transition: "all 0.2s ease-in-out 0s",
      position: "relative",
      width: "".concat(progressWidth > 100 ? 100 : progressWidth < 0 ? 0 : progressWidth, "%")
    },
    role: "progressbar",
    "aria-valuenow": value,
    "aria-valuemin": min,
    "aria-valuemax": max,
    variant: barVariant,
    variantKey: "progresses",
    sx: progressSx
  }, children));
}

function _extends$1() {
  return (_extends$1 = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) Object.prototype.hasOwnProperty.call(source, key) && (target[key] = source[key]);
    }
    return target;
  }).apply(this, arguments);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _unsupportedIterableToArray(o, minLen) {
  if (o) {
    if ("string" == typeof o) return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    return "Object" === n && o.constructor && (n = o.constructor.name), "Map" === n || "Set" === n ? Array.from(o) : "Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n) ? _arrayLikeToArray(o, minLen) : void 0;
  }
}

function _arrayLikeToArray(arr, len) {
  (null == len || len > arr.length) && (len = arr.length);
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}

function _iterableToArrayLimit(arr, i) {
  if ("undefined" != typeof Symbol && Symbol.iterator in Object(arr)) {
    var _arr = [], _n = !0, _d = !1, _e = void 0;
    try {
      for (var _s, _i = arr[Symbol.iterator](); !(_n = (_s = _i.next()).done) && (_arr.push(_s.value), 
      !i || _arr.length !== i); _n = !0) ;
    } catch (err) {
      _d = !0, _e = err;
    } finally {
      try {
        _n || null == _i.return || _i.return();
      } finally {
        if (_d) throw _e;
      }
    }
    return _arr;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _objectWithoutProperties$1(source, excluded) {
  if (null == source) return {};
  var key, i, target = _objectWithoutPropertiesLoose$1(source, excluded);
  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);
    for (i = 0; i < sourceSymbolKeys.length; i++) key = sourceSymbolKeys[i], excluded.indexOf(key) >= 0 || Object.prototype.propertyIsEnumerable.call(source, key) && (target[key] = source[key]);
  }
  return target;
}

function _objectWithoutPropertiesLoose$1(source, excluded) {
  if (null == source) return {};
  var key, i, target = {}, sourceKeys = Object.keys(source);
  for (i = 0; i < sourceKeys.length; i++) key = sourceKeys[i], excluded.indexOf(key) >= 0 || (target[key] = source[key]);
  return target;
}

function ProgressThumb(_ref) {
  var value = _ref.value, min = _ref.min, max = _ref.max, _ref$variant = _ref.variant, variant = void 0 === _ref$variant ? "thumb" : _ref$variant, _ref$variantKey = _ref.variantKey, variantKey = void 0 === _ref$variantKey ? "progresses" : _ref$variantKey, children = _ref.children, props = _objectWithoutProperties$1(_ref, [ "value", "min", "max", "variant", "variantKey", "children" ]), _useMeasure2 = _slicedToArray(useMeasure.useMeasure(), 2), bind = _useMeasure2[0], width = _useMeasure2[1].width;
  return React.createElement(box.Box, _extends$1({}, bind, {
    __base: {
      bg: "white",
      border: "1px solid",
      borderColor: "muted",
      borderRadius: "default",
      left: min && value <= min ? 0 : max && value >= max ? "auto" : "calc(100% - ".concat(width / 2, "px)"),
      lineHeight: 1,
      p: 2,
      position: "absolute",
      right: max && value >= max ? "0" : "auto",
      top: "50%",
      transform: "translateY(-50%)"
    },
    variant: variant,
    variantKey: variantKey
  }, props), children || value);
}

exports.Progress = Progress, exports.ProgressThumb = ProgressThumb;
